#!/bin/sh
# the next line restarts using tclsh \
    exec tclsh "$0" "$@"

# Produces an pretty HTML report.
# $Id: htmlfrontend.tcl,v 1.1 2002/11/15 23:58:13 davidw Exp $
# Copyright David N. Welton <davidw@dedasys.com>
# See license.terms for licensing terms.

source [file join . linkcheck.tcl]

proc main {} {
    global argv argc

    set url [lindex $argv 0]
    set depth [lindex $argv 1]
    if { $url == "" || $argc < 1 || $argc > 2} {
	Usage
    }
    if { $depth == "" } {
	set depth 3
    }

    linkcheck::Init [lindex $argv 0]
    linkcheck::Robots
    linkcheck::Configure depth [lindex $argv 1]
    linkcheck::Run

    set site [lindex $argv 0]
    set numlinks [linkcheck::Stats visited]
    set goodlinks [linkcheck::Stats good]
    set badlinks [linkcheck::Stats bad]

    append Links "<ul>\n"
    foreach ln [lsort [linkcheck::Stats code 4??]] {
	append Links "<li><a href=\"$ln\">$ln</a><br>\n"
	append Links "which is linked from the following pages:</li>"
	append Links "<ul>\n"
	foreach pg [lsort [linkcheck::Stats linkedfrom $ln]] {
	    append Links "<li><a href=\"$pg\">$pg</a></li>"
	}
	append Links "</ul>\n"
    }
    append Links "</ul>"
    linkcheck::End

    set rf [open report.html]
    set data [read $rf]
    close $rf
    set report [subst -nobackslashes -nocommands $data]
    set fl [open output.html w]
    puts $fl $report
    close $fl
}

main